import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["isHeading"];
import { getProcessor, getCodeBlock, getHeadings } from './utils';
export * from './utils';
export var FUNNAME_PREFIX = '__BaseCode__';
var codePreviewLoader = function codePreviewLoader(source) {
  var options = this.getOptions();
  var {
      isHeading
    } = options,
    rest = _objectWithoutPropertiesLoose(options, _excluded);
  var components = '';
  var codeBlock = {};
  var child = getProcessor(source);
  try {
    codeBlock = getCodeBlock(child, rest, this.resourcePath);
    Object.keys(codeBlock).forEach(key => {
      components += key + ": (function() { " + codeBlock[key].code + " })(),";
    });
  } catch (error) {
    this.emitError(error);
  }
  var {
    headingsList,
    headings
  } = isHeading ? getHeadings(child) : {
    headingsList: [],
    headings: []
  };
  return "\nexport default {\n    components: { " + components + " },\n    data: " + JSON.stringify(codeBlock, null, 2) + ",\n    source: " + JSON.stringify(source) + ",\n    headings:" + JSON.stringify(headings) + ",\n    headingsList:" + JSON.stringify(headingsList) + ",\n  }";
};
export default codePreviewLoader;