"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  FUNNAME_PREFIX: true
};
exports["default"] = exports.FUNNAME_PREFIX = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _utils = require("./utils");
Object.keys(_utils).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _utils[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _utils[key];
    }
  });
});
var _excluded = ["isHeading"];
var FUNNAME_PREFIX = exports.FUNNAME_PREFIX = '__BaseCode__';
var codePreviewLoader = function codePreviewLoader(source) {
  var options = this.getOptions();
  var isHeading = options.isHeading,
    rest = (0, _objectWithoutProperties2["default"])(options, _excluded);
  var components = '';
  var codeBlock = {};
  var child = (0, _utils.getProcessor)(source);
  try {
    codeBlock = (0, _utils.getCodeBlock)(child, rest, this.resourcePath);
    Object.keys(codeBlock).forEach(function (key) {
      components += "".concat(key, ": (function() { ").concat(codeBlock[key].code, " })(),");
    });
  } catch (error) {
    this.emitError(error);
  }
  var _ref = isHeading ? (0, _utils.getHeadings)(child) : {
      headingsList: [],
      headings: []
    },
    headingsList = _ref.headingsList,
    headings = _ref.headings;
  return "\nexport default {\n    components: { ".concat(components, " },\n    data: ").concat(JSON.stringify(codeBlock, null, 2), ",\n    source: ").concat(JSON.stringify(source), ",\n    headings:").concat(JSON.stringify(headings), ",\n    headingsList:").concat(JSON.stringify(headingsList), ",\n  }");
};
var _default = exports["default"] = codePreviewLoader;